import { openBlock as a, createElementBlock as d, createElementVNode as s, renderSlot as i, computed as v, normalizeClass as _, unref as u, resolveComponent as y, createBlock as $, withCtx as f, withDirectives as g, isRef as C, vModelCheckbox as w, toDisplayString as c, createCommentVNode as p, ref as B, onMounted as N, Fragment as q, createVNode as h, inject as S, vModelRadio as D, provide as k } from "vue";
const V = (l, t) => {
  const e = l.__vccOpts || l;
  for (const [o, n] of t)
    e[o] = n;
  return e;
}, I = {}, M = { class: "cf-app-bar" };
function A(l, t) {
  return a(), d("header", M, [
    s("div", null, [
      i(l.$slots, "left")
    ]),
    s("div", null, [
      i(l.$slots, "right")
    ])
  ]);
}
const L = /* @__PURE__ */ V(I, [["render", A]]);
const Ee = {
  __name: "CfAppBody",
  props: {
    wide: {
      type: Boolean,
      default: !1
    }
  },
  setup(l) {
    const t = l, e = v(() => ({
      "cf-app-body": !0,
      "cf-app-body--wide": t.wide
    }));
    return (o, n) => (a(), d("div", {
      class: _(u(e))
    }, [
      i(o.$slots, "default")
    ], 2));
  }
};
const R = ["type", "disabled"], Oe = {
  __name: "CfButton",
  props: {
    to: {
      type: String,
      default: null
    },
    type: {
      type: String,
      default: "button"
    },
    variant: {
      type: String,
      default: null
    },
    large: {
      type: Boolean,
      default: !1
    },
    wide: {
      type: Boolean,
      default: !1
    },
    loading: {
      type: Boolean,
      default: !1
    },
    disabled: {
      type: Boolean,
      default: !1
    },
    faux: {
      type: Boolean,
      default: !1
    }
  },
  setup(l) {
    const t = l, e = v(() => ({
      "cf-button": !0,
      [`cf-button--${t.variant}`]: t.variant,
      "cf-button--large": t.large,
      "cf-button--wide": t.wide,
      "cf-button--loading": t.loading,
      "cf-button--disabled": t.disabled
    }));
    return (o, n) => {
      const r = y("router-link");
      return l.to ? (a(), $(r, {
        key: 0,
        class: _(u(e)),
        to: l.to
      }, {
        default: f(() => [
          i(o.$slots, "default")
        ]),
        _: 3
      }, 8, ["class", "to"])) : l.faux ? (a(), d("div", {
        key: 1,
        class: _(u(e))
      }, [
        i(o.$slots, "default")
      ], 2)) : (a(), d("button", {
        key: 2,
        class: _(u(e)),
        type: t.type,
        disabled: t.disabled
      }, [
        i(o.$slots, "default")
      ], 10, R));
    };
  }
};
const U = { class: "cf-checkbox" }, z = ["id", "value", "true-value", "false-value", "disabled"], E = ["for"], O = {
  key: 0,
  class: "cf-checkbox__helper"
}, je = {
  __name: "CfCheckbox",
  props: {
    modelValue: [Number, String, Boolean, Array],
    label: String,
    helper: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, o = v({
      get() {
        return e.modelValue;
      },
      set(r) {
        t("update:modelValue", r);
      }
    }), n = Math.random();
    return (r, b) => (a(), d("div", U, [
      g(s("input", {
        class: "cf-checkbox__input",
        "onUpdate:modelValue": b[0] || (b[0] = (m) => C(o) ? o.value = m : null),
        type: "checkbox",
        id: u(n),
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, z), [
        [w, u(o)]
      ]),
      s("div", null, [
        s("label", {
          class: "cf-checkbox__label",
          for: u(n)
        }, c(e.label), 9, E),
        e.helper ? (a(), d("div", O, c(e.helper), 1)) : p("", !0)
      ])
    ]));
  }
};
const j = { class: "cf-sidebar-nav" }, F = /* @__PURE__ */ s("hr", null, null, -1), H = /* @__PURE__ */ s("span", { class: "material-symbols-outlined" }, null, -1), T = /* @__PURE__ */ s("span", null, "Collapse sidebar", -1), G = [
  H,
  T
], J = {
  __name: "CfSidebar",
  setup(l) {
    const t = B(!1), e = v(() => ({
      "cf-sidebar": !0,
      "cf-sidebar--toggled": t.value
    }));
    return (o, n) => (a(), d("aside", {
      class: _(u(e))
    }, [
      s("nav", j, [
        i(o.$slots, "default"),
        F
      ]),
      s("button", {
        class: "cf-sidebar-toggle",
        onClick: n[0] || (n[0] = (r) => t.value = !t.value)
      }, G)
    ], 2));
  }
};
const Fe = {
  __name: "CfDefaultLayout",
  setup(l) {
    return N(() => {
      document.body.dataset.layout = "default";
    }), (t, e) => (a(), d(q, null, [
      h(L, null, {
        left: f(() => [
          i(t.$slots, "brand")
        ]),
        right: f(() => [
          i(t.$slots, "navigation")
        ]),
        _: 3
      }),
      h(J, null, {
        default: f(() => [
          i(t.$slots, "sidebar")
        ]),
        _: 3
      }),
      s("main", null, [
        i(t.$slots, "main")
      ])
    ], 64));
  }
};
const K = { class: "cf-dropdown-body" }, P = {
  __name: "CfDropdown",
  setup(l) {
    const t = B(!1), e = v(() => ({
      "cf-dropdown": !0,
      "cf-dropdown--open": t.value
    }));
    return (o, n) => (a(), d("div", {
      class: _(u(e))
    }, [
      s("div", {
        class: "cf-dropdown-toggle",
        onClick: n[0] || (n[0] = (r) => t.value = !t.value)
      }, [
        i(o.$slots, "toggle")
      ]),
      s("div", K, [
        i(o.$slots, "body")
      ]),
      s("div", {
        class: "cf-dropdown-backdrop",
        onClick: n[1] || (n[1] = (r) => t.value = !1)
      })
    ], 2));
  }
};
const Q = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, W = { class: "material-symbols-outlined" }, X = { class: "cf-dropdown-item__label" }, Y = {
  key: 0,
  class: "cf-dropdown-item__icon"
}, Z = { class: "material-symbols-outlined" }, ee = { class: "cf-dropdown-item__label" }, He = {
  __name: "CfDropdownItem",
  props: {
    icon: String,
    to: String,
    large: Boolean
  },
  setup(l) {
    const t = l, e = v(() => ({
      "cf-dropdown-item": !0,
      "cf-dropdown-item--large": t.large
    }));
    return (o, n) => {
      const r = y("router-link");
      return l.to ? (a(), $(r, {
        key: 1,
        class: _(u(e)),
        to: l.to
      }, {
        default: f(() => [
          l.icon ? (a(), d("div", Y, [
            s("span", Z, c(l.icon), 1)
          ])) : p("", !0),
          s("div", ee, [
            i(o.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["class", "to"])) : (a(), d("button", {
        key: 0,
        class: _(u(e))
      }, [
        l.icon ? (a(), d("div", Q, [
          s("span", W, c(l.icon), 1)
        ])) : p("", !0),
        s("div", X, [
          i(o.$slots, "default")
        ])
      ], 2));
    };
  }
};
const te = { class: "cf-input" }, le = ["value", "type", "placeholder", "required", "disabled", "readonly"], se = { class: "cf-input__label" }, oe = {
  key: 0,
  class: "cf-input__helper"
}, Te = {
  __name: "CfInput",
  props: {
    modelValue: [Number, String],
    label: String,
    placeholder: String,
    helper: String,
    required: Boolean,
    disabled: Boolean,
    readonly: Boolean,
    type: {
      type: String,
      default: "text"
    }
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l;
    return (o, n) => (a(), d("div", te, [
      s("input", {
        class: "cf-input__field",
        value: e.modelValue,
        type: e.type,
        placeholder: e.placeholder,
        required: e.required,
        disabled: e.disabled,
        readonly: e.readonly,
        onInput: n[0] || (n[0] = (r) => t("update:modelValue", r.target.value))
      }, null, 40, le),
      s("label", se, c(e.label), 1),
      e.helper ? (a(), d("div", oe, c(e.helper), 1)) : p("", !0)
    ]));
  }
};
const ne = {
  key: 0,
  class: "cf-nav-item"
}, ae = { class: "cf-nav-item__label" }, de = /* @__PURE__ */ s("svg", {
  xmlns: "http://www.w3.org/2000/svg",
  viewBox: "0 0 16 16",
  width: "16"
}, [
  /* @__PURE__ */ s("path", { d: "M14.15 4.492H1.85l-.354.854 6.15 6.15h.707l6.15-6.15-.353-.854z" })
], -1), ie = {
  key: 1,
  class: "cf-nav-item"
}, re = { class: "cf-nav-item__label" }, Ge = {
  __name: "CfNavItem",
  props: {
    dropdown: Boolean
  },
  setup(l) {
    return (t, e) => l.dropdown ? (a(), d("div", ne, [
      h(P, null, {
        toggle: f(() => [
          s("div", ae, [
            i(t.$slots, "default"),
            de
          ])
        ]),
        body: f(() => [
          i(t.$slots, "dropdown")
        ]),
        _: 3
      })
    ])) : (a(), d("button", ie, [
      s("div", re, [
        i(t.$slots, "default")
      ])
    ]));
  }
};
const ue = { class: "cf-radio" }, ce = ["id", "name", "value", "required", "disabled"], _e = ["for"], fe = {
  key: 0,
  class: "cf-radio__helper"
}, Je = {
  __name: "CfRadio",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    helper: String,
    value: [Number, String, Boolean],
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, o = Math.random(), n = {
      name: S("selection-name"),
      required: S("selection-required")
    }, r = v({
      get() {
        return e.modelValue;
      },
      set(b) {
        t("update:modelValue", b);
      }
    });
    return (b, m) => (a(), d("div", ue, [
      g(s("input", {
        class: "cf-radio__input",
        "onUpdate:modelValue": m[0] || (m[0] = (x) => C(r) ? r.value = x : null),
        type: "radio",
        id: u(o),
        name: n.name,
        value: e.value,
        required: n.required,
        disabled: e.disabled
      }, null, 8, ce), [
        [D, u(r)]
      ]),
      s("div", null, [
        s("label", {
          class: "cf-radio__label",
          for: u(o)
        }, c(e.label), 9, _e),
        e.helper ? (a(), d("div", fe, c(e.helper), 1)) : p("", !0)
      ])
    ]));
  }
};
const pe = { class: "cf-select" }, ve = ["value", "required", "disabled"], be = { class: "cf-select__label" }, me = {
  key: 0,
  class: "cf-select__helper"
}, Ke = {
  __name: "CfSelect",
  props: {
    modelValue: [Number, String],
    label: String,
    helper: String,
    required: Boolean,
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l;
    return (o, n) => (a(), d("div", pe, [
      s("select", {
        class: "cf-select__field",
        value: e.modelValue,
        required: e.required,
        disabled: e.disabled,
        onInput: n[0] || (n[0] = (r) => t("update:modelValue", r.target.value))
      }, [
        i(o.$slots, "default")
      ], 40, ve),
      s("label", be, c(e.label), 1),
      e.helper ? (a(), d("div", me, c(e.helper), 1)) : p("", !0)
    ]));
  }
};
const he = ["inert"], ye = {
  key: 0,
  class: "cf-selection-label"
}, Pe = {
  __name: "CfSelection",
  props: {
    label: String,
    disabled: Boolean,
    required: {
      type: Boolean,
      default: !1
    }
  },
  setup(l) {
    const t = l;
    return k("selection-name", Math.random()), k("selection-required", t.required), (e, o) => (a(), d("div", {
      class: "cf-selection",
      inert: l.disabled
    }, [
      l.label ? (a(), d("div", ye, c(l.label), 1)) : p("", !0),
      i(e.$slots, "default")
    ], 8, he));
  }
};
const $e = { class: "cf-sidebar-link__icon" }, ge = { class: "material-symbols-outlined" }, Ce = { class: "cf-sidebar-link__label" }, Se = ["href"], ke = { class: "cf-sidebar-link__icon" }, we = { class: "material-symbols-outlined" }, Be = { class: "cf-sidebar-link__label" }, Qe = {
  __name: "CfSidebarLink",
  props: {
    to: String,
    href: String,
    icon: String
  },
  setup(l) {
    const t = l;
    return (e, o) => {
      const n = y("router-link");
      return l.to ? (a(), $(n, {
        key: 0,
        class: "cf-sidebar-link",
        to: t.to
      }, {
        default: f(() => [
          s("div", $e, [
            s("span", ge, c(l.icon), 1)
          ]),
          s("div", Ce, [
            i(e.$slots, "default")
          ])
        ]),
        _: 3
      }, 8, ["to"])) : (a(), d("a", {
        key: 1,
        class: "cf-sidebar-link",
        href: l.href
      }, [
        s("div", ke, [
          s("span", we, c(l.icon), 1)
        ]),
        s("div", Be, [
          i(e.$slots, "default")
        ])
      ], 8, Se));
    };
  }
};
const Ve = {}, xe = { class: "cf-spinner" }, Ne = /* @__PURE__ */ s("div", null, null, -1), qe = /* @__PURE__ */ s("div", null, null, -1), De = /* @__PURE__ */ s("div", null, null, -1), Ie = /* @__PURE__ */ s("div", null, null, -1), Me = [
  Ne,
  qe,
  De,
  Ie
];
function Ae(l, t) {
  return a(), d("div", xe, Me);
}
const We = /* @__PURE__ */ V(Ve, [["render", Ae]]);
const Le = { class: "cf-switch" }, Re = ["value", "true-value", "false-value", "disabled"], Ue = {
  key: 0,
  class: "cf-switch__label"
}, Xe = {
  __name: "CfSwitch",
  props: {
    modelValue: [Number, String, Boolean],
    label: String,
    value: [Number, String, Boolean],
    trueValue: {
      type: [Number, String, Boolean],
      default: !0
    },
    falseValue: {
      type: [Number, String, Boolean],
      default: !1
    },
    disabled: Boolean
  },
  emits: ["update:modelValue"],
  setup(l, { emit: t }) {
    const e = l, o = v({
      get() {
        return e.modelValue;
      },
      set(n) {
        t("update:modelValue", n);
      }
    });
    return (n, r) => (a(), d("div", Le, [
      g(s("input", {
        class: "cf-switch__box",
        "onUpdate:modelValue": r[0] || (r[0] = (b) => C(o) ? o.value = b : null),
        type: "checkbox",
        value: e.value,
        "true-value": e.trueValue,
        "false-value": e.falseValue,
        disabled: e.disabled
      }, null, 8, Re), [
        [w, u(o)]
      ]),
      e.label ? (a(), d("div", Ue, c(e.label), 1)) : p("", !0)
    ]));
  }
};
export {
  L as CfAppBar,
  Ee as CfAppBody,
  Oe as CfButton,
  je as CfCheckbox,
  Fe as CfDefaultLayout,
  P as CfDropdown,
  He as CfDropdownItem,
  Te as CfInput,
  Ge as CfNavItem,
  Je as CfRadio,
  Ke as CfSelect,
  Pe as CfSelection,
  J as CfSidebar,
  Qe as CfSidebarLink,
  We as CfSpinner,
  Xe as CfSwitch
};
